OGRE: Ogre::MovablePlane Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::MovablePlane Class Reference
Core » Scene

Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply. More...

`#include <OgreMovablePlane.h>`

Inheritance diagram for Ogre::MovablePlane:
[legend]

## Public Member Functions
| MovablePlane (const Plane &rhs)
| MovablePlane (const String &name)
| MovablePlane (const Vector3 &rkNormal, const Vector3 &rkPoint)
| MovablePlane (const Vector3 &rkNormal, Real fConstant)
| Construct a plane through a normal, and a distance to move the plane along the normal.
| MovablePlane (const Vector3 &rkPoint0, const Vector3 &rkPoint1, const Vector3 &rkPoint2)
| ~MovablePlane ()
const Plane & | _getDerivedPlane (void) const
| Get the derived plane as transformed by its parent node.
void | _notifyCurrentCamera (Camera *) override
| Overridden from MovableObject.
void | _updateRenderQueue (RenderQueue *) override
| Overridden from MovableObject.
const AxisAlignedBox & | getBoundingBox (void) const override
| Overridden from MovableObject.
Real | getBoundingRadius (void) const override
| Overridden from MovableObject.
const String & | getMovableType (void) const override
| Overridden from MovableObject.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::Plane
| Plane ()
| Default constructor - sets everything to 0.
| Plane (const Vector3 &p0, const Vector3 &p1, const Vector3 &p2)
| Plane (const Vector3 &rkNormal, const Vector3 &rkPoint)
| Plane (const Vector3 &rkNormal, Real fConstant)
| Construct a plane through a normal, and a distance to move the plane along the normal.
| Plane (const Vector4 &v)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
| Plane (Real a, Real b, Real c, Real _d)
| Construct a plane using the 4 constants directly.
Real | getDistance (const Vector3 &rkPoint) const
| This is a pseudodistance.
Side | getSide (const AxisAlignedBox &box) const
| Returns the side where the alignedBox is.
Side | getSide (const Vector3 &centre, const Vector3 &halfSize) const
| Returns which side of the plane that the given box lies on.
Side | getSide (const Vector3 &rkPoint) const
Real | normalise (void)
| Normalises the plane.
bool | operator!= (const Plane &rhs) const
Plane | operator- () const
| Get flipped plane, with same location but reverted orientation.
bool | operator== (const Plane &rhs) const
| Comparison operator.
Vector3 | projectVector (const Vector3 &v) const
| Project a vector onto the plane.
void | redefine (const Vector3 &p0, const Vector3 &p1, const Vector3 &p2)
| Redefine this plane based on 3 points.
void | redefine (const Vector3 &rkNormal, const Vector3 &rkPoint)
| Redefine this plane based on a normal and a point.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Additional Inherited Members
Public Types inherited from Ogre::Plane
enum | Side { NO_SIDE , POSITIVE_SIDE , NEGATIVE_SIDE , BOTH_SIDE }
| The "positive side" of the plane is the half space to which the plane normal points. More...
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
Public Attributes inherited from Ogre::Plane
Real | d
Vector3 | normal

## Detailed Description

Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply.

This plane is not here for rendering purposes, it's to allow you to attach planes to the scene in order to have them move and follow nodes on their own, which is useful if you're using the plane for some kind of calculation, e.g. reflection.

## Constructor & Destructor Documentation

## ◆ MovablePlane() [1/5]

Ogre::MovablePlane::MovablePlane | ( | const String & | name | ) |

## ◆ MovablePlane() [2/5]

Ogre::MovablePlane::MovablePlane | ( | const Plane & | rhs | ) |

References Ogre::Plane::Plane().

## ◆ MovablePlane() [3/5]

Ogre::MovablePlane::MovablePlane | ( | const Vector3 & | rkNormal,
|  | Real | fConstant )

Construct a plane through a normal, and a distance to move the plane along the normal.

## ◆ MovablePlane() [4/5]

Ogre::MovablePlane::MovablePlane | ( | const Vector3 & | rkNormal,
|  | const Vector3 & | rkPoint )

## ◆ MovablePlane() [5/5]

Ogre::MovablePlane::MovablePlane | ( | const Vector3 & | rkPoint0,
|  | const Vector3 & | rkPoint1,
|  | const Vector3 & | rkPoint2 )

## ◆ ~MovablePlane()

Ogre::MovablePlane::~MovablePlane | ( |  | ) |
| inline

## Member Function Documentation

## ◆ _notifyCurrentCamera()

void Ogre::MovablePlane::_notifyCurrentCamera | ( | Camera * |  | ) |
| inlineoverridevirtual

Overridden from MovableObject.

Reimplemented from Ogre::MovableObject.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::MovablePlane::getBoundingBox | ( | void |  | ) | const
| inlineoverridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

References Ogre::AxisAlignedBox::BOX_NULL.

## ◆ getBoundingRadius()

Real Ogre::MovablePlane::getBoundingRadius | ( | void |  | ) | const
| inlineoverridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ _updateRenderQueue()

void Ogre::MovablePlane::_updateRenderQueue | ( | RenderQueue * |  | ) |
| inlineoverridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ getMovableType()

const String & Ogre::MovablePlane::getMovableType | ( | void |  | ) | const
| overridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ _getDerivedPlane()

const Plane & Ogre::MovablePlane::_getDerivedPlane | ( | void |  | ) | const

Get the derived plane as transformed by its parent node.

References Ogre::Plane::Plane().

## ◆ visitRenderables()

void Ogre::MovablePlane::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| inlineoverridevirtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

The documentation for this class was generated from the following file:

- OgreMovablePlane.h